/*
	gfx.c

	Simple graphics stuff such as setting the video mode, etc.

	Copyright (C) 2001 Sparkle Game Company
*/

#include "gfx.h"
#include "string.h"

/* helpful defines for page flipping */
#define VRAM_PAGE1		0x06000000
#define VRAM_PAGE2		0x06009600
#define VRAM_START		VRAM_PAGE1

/* the screen */
u16 *screen = (u16 *)VRAM_START;

void set_gfx_mode(u16 mode)
{
	switch(mode)
	{
	case GFX_MODE3:
	case GFX_MODE4:
		*((u32 *)DISPLAY_CTRL) = (u32)(mode | BG2_ENABLE);
		break;
	default:
		*((u32 *)DISPLAY_CTRL) = (u32)mode;
	}
}

void set_bg_palette(u16 *pal)
{
	memcpy((void *)PALETTE_BG, pal, 512);
}

void set_sprite_palette(u16 *pal)
{
	memcpy((void *)PALETTE_SPRITE, pal, 512);
}