/*
	vfs.c

	Virtual file system i/o.

	Copyright (C) 2001 Sparkle Game Company
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "vfs.h"

u32 vfs_fopen(char *file)
{
	int i;
	u32 handle = 0;
	u32 *addr;
	u32 numfiles;
	char *ptr;
	char *str;

	/* need to make a copy, since 'file' might point to a literal (ROM) */
	str = (char *)malloc(strlen(file) + 1);
	strcpy(str, file);

	/* see vfs.h for info on CONVERT_FILENAMES */
#ifdef CONVERT_FILENAMES
	i = 0;
	while(str[i] != '\0')
	{
		if(str[i] == ' ')
			str[i] = 'x';

		if(str[i] == '.')
			str[i] = '_';
	
		i++;
	}
#endif /* CONVERT_FILENAMES */

	addr = (u32 *)(0x08000000  + PADDED_TO + 6);
	ptr = (u8 *)addr;
	numfiles = *ptr;
	ptr++;		/* move on to the first file name */

	for(i = 0; i < numfiles; i++)
	{
		if(!strcmp(ptr, str))		/* we've found our match */
		{
			ptr += strlen(ptr) + 1;
			addr = (u32 *)ptr;
			handle = (u32)addr;
			break;
		}
		
		ptr += strlen(ptr) + 9;
	}

	
	free(str);
	return handle;
}