/*      tp2gp.c (tUME pal -> GBA pal)

        Converts tUME .PAL files to a format compatible with the GBA.

        Copyright (C) 2001 Sparkle Game Company
*/

#define RGB(r,g,b)  ((r)+(g<<5)+(b<<10))

#include <stdio.h>


int main(int argc, char *argv[])
{
	FILE *in, *out;
        unsigned char r, g, b;
        unsigned short gba_triplet;

        if(argc != 3)
        {
                printf("tUME pal to GBA pal converter\n");
                printf("tp2gp.exe - usage:\n\n");
                printf("tp2gp in.pal out.pal\n");
                return -1;
        }


        if(!(in = fopen(argv[1], "rb")))
        {
                printf("tUME pal to GBA pal converter\n");
                printf("tp2gp.exe - error opening %s\n", argv[1]);
                return -1;
        }

        if(!(out = fopen(argv[2], "wb")))
        {
                printf("tUME pal to GBA pal converter\n");
                printf("tp2gp.exe - error creating %s\n", argv[2]);
                return -1;
        }

        r = (unsigned char) fgetc(in);
        g = (unsigned char) fgetc(in);
        b = (unsigned char) fgetc(in);

	while(!feof(in))
	{
                gba_triplet = 0;
                gba_triplet = RGB(r, g, b);

                fwrite(&gba_triplet, sizeof(unsigned short), 1, out);

                r = (unsigned char) fgetc(in);
                g = (unsigned char) fgetc(in);
                b = (unsigned char) fgetc(in);
	}

	fclose(out);
	fclose(in);
	
        return 0;
}
