// vfsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "vfs.h"
#include "vfsDlg.h"
#include <vector>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// string storage ------
using namespace std;
vector<CString> strings;		// for storing our files with paths
vector<CString> stringsShort;	// for storing our files without paths
int numStrings = 0;

/////////////////////////////////////////////////////////////////////////////
// CVfsDlg dialog

CVfsDlg::CVfsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVfsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVfsDlg)
	m_originalRomRadio = 0;
	m_finalRomRadio = 0;
	m_inRom = _T("");
	m_outRom = _T("");
	m_listString = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	//m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVfsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVfsDlg)
	DDX_Control(pDX, IDC_FILELIST, m_listBox);
	DDX_Radio(pDX, IDC_OR_128, m_originalRomRadio);
	DDX_Radio(pDX, IDC_FR_DO_NOT, m_finalRomRadio);
	DDX_Text(pDX, IDC_INROM, m_inRom);
	DDX_Text(pDX, IDC_OUTROM, m_outRom);
	DDX_LBString(pDX, IDC_FILELIST, m_listString);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVfsDlg, CDialog)
	//{{AFX_MSG_MAP(CVfsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE1, OnBrowse1)
	ON_BN_CLICKED(IDC_BROWSE2, OnBrowse2)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_LBN_DBLCLK(IDC_FILELIST, OnDblclkFilelist)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVfsDlg message handlers

BOOL CVfsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
//	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVfsDlg::OnPaint() 
{
/*	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{*/
		CDialog::OnPaint();
//	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVfsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVfsDlg::OnBrowse1() 
{
	UpdateData(TRUE);
	
	/* get input rom name */
	CFileDialog fbox(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, 
		"GBA roms (*.bin; *.gba; *.agb)|*.bin;*.gba;*.agb|All Files (*.*)|*.*|");
	
	if(fbox.DoModal() == IDOK)
	{
		m_inRom = fbox.GetPathName();
		UpdateData(FALSE);
	}
	
}

void CVfsDlg::OnBrowse2() 
{
	UpdateData(TRUE);
	
	CFileDialog fbox(FALSE, NULL, NULL, OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY,
		"GBA roms (*.bin; *.gba; *.agb)|*.bin;*.gba;*.agb|All Files(*.*)|*.*|");

	if(fbox.DoModal() == IDOK)
	{
		/* are the output and input file the same? */
		if(fbox.GetPathName().CompareNoCase(m_inRom) == 0)
		{
			MessageBox("Output and input files cannot be the same!");
			return;
		}
		
		m_outRom = fbox.GetPathName();
		UpdateData(FALSE);
	}
}


void CVfsDlg::OnAdd()
{
	CFileDialog fbox(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, 
		"All Files(*.*)|*.*|");

	UpdateData(TRUE);
	
	if(fbox.DoModal() == IDOK)
	{
		CString str1, str2;
		
		// make a copy of the current file to be added
		str1 = fbox.GetFileName();
		str1.MakeLower();

		// make sure a file with the same name does not already exist
		for(int i = 0; i < numStrings; i++)
		{
			str2 = stringsShort[i];
			str2.MakeLower();

			if(str1 == str2)
			{
				MessageBox("Cannot have duplicate file names!");
				return;
			}
		}

		
		strings.push_back(fbox.GetPathName());		// store full filename with path
		stringsShort.push_back(fbox.GetFileName());	// store just file name

		numStrings++;
		
		m_listBox.AddString(fbox.GetFileName());		// display filename without path
		UpdateData(FALSE);
	}
}


// when a file in the list is double-clicked, info is displayed
void CVfsDlg::OnDblclkFilelist() 
{
	CString info;
	CFileStatus status;
	int index = 0;
	char buffer[20];

	UpdateData(TRUE);

	index = m_listBox.GetCurSel();
	if(index == LB_ERR)		// should never happen, but you never know ;-)
		return;

	CFile::GetStatus(strings[index], status);
	info = "Name: \t\t" + (CString)status.m_szFullName + "\n";
	info += "Size: \t\t" + (CString)itoa(status.m_size, buffer, 10) + " bytes\n";
	
	info += "Created: \t\t" + status.m_ctime.Format("%m/%d/%y (%H:%M.%S)");
	info += "\nLast modified:\t" + status.m_mtime.Format("%m/%d/%y (%H:%M.%S)");

	MessageBox(info, "File info");
}

void CVfsDlg::OnOK() 
{
	FILE *in, *out;
	
	UpdateData(TRUE);

	if(m_inRom == "")
	{
		MessageBox("You must specify an input rom file.");
		return;
	}

	if(m_outRom == "")
	{
		MessageBox("You must specify an output rom file.");
		return;
	}

	if(numStrings == 0)
	{
		MessageBox("You must add at least one file to the file list.");
		return;
	}
		
	// test to make sure the input and output roms are valid names
	in = fopen(m_inRom, "rb");
	if(!in)
	{
		MessageBox("Input rom file does not exist.");
		return;
	}
	fclose(in);

	out = fopen(m_outRom, "wb");
	if(!out)
	{
		MessageBox("Invalid name for output rom file.");
		return;
	}
	fclose(out);

	// at this point, everything should be valid
	if(!GenerateVFS())
		return;

	CDialog::OnOK();
}

void CVfsDlg::OnRemove() 
{
	int index = 0;

	UpdateData(TRUE);

	index = m_listBox.GetCurSel();
	if(index == LB_ERR)
		return;

	// remove from list box
	m_listBox.DeleteString(m_listBox.GetCurSel());
	
	// remove from storage
	strings.erase(strings.begin() + index);
	stringsShort.erase(stringsShort.begin() + index);
	numStrings--;

	UpdateData(FALSE);
}

// VFS header struct - provides info for the files that are in the VFS
struct vfs_header_t
{
	unsigned long size;					// size of the header
	char VFS_HDR[6];

};

vfs_header_t vfs_header;


int CVfsDlg::GenerateVFS()
{
	FILE *in, *out;
	unsigned char data;
	unsigned long mem_addr;
	unsigned long i;
	
	CFileStatus status;					/* file sizes */
	unsigned long firstPadSize = 0;
	unsigned long numZeros = 0;
	unsigned long mem_offset = 0;

	/* sizes to pad original ROM image to before adding the VFS */
	switch(m_originalRomRadio)
	{
	case 0:	firstPadSize = 131072L;			break;
	case 1:	firstPadSize = 524288L;			break;
	case 2: firstPadSize = 1048576L;		break;
	case 3: firstPadSize = 2097152L;		break;
	case 4:	firstPadSize = 4194304L;		break;
	case 5: firstPadSize = 8388608L;		break;
	default: break;
	}

	// initialize 6byte magic value
	strcpy(vfs_header.VFS_HDR, "VFSHDR");
	
	CFile::GetStatus(m_inRom, status);
	
	// is rom bigger than padding?
	if(status.m_size > firstPadSize)
	{
		MessageBox(
			"Input rom file is larger than padding. \nPlease pick a bigger size");
		return 0;
	}

	// get the number of zeros to pad to the end of input rom
	numZeros = firstPadSize - status.m_size;

	in = fopen(m_inRom, "rb");
	if(!in)
	{
		MessageBox("Error opening input rom file.");
		return 0;
	}

	out = fopen(m_outRom, "wb");
	if(!out)
	{
		MessageBox("Error creating output rom file.");
		return 0;
	}
	
	// copy over input rom image
	data = (unsigned char) fgetc(in);

	while(!feof(in))
	{
		fputc(data, out);
		data = (unsigned char) fgetc(in);
	}
	fclose(in);

	// add zeros
	for(i = 0; i < numZeros; i++)
	{
		fputc(0, out);
	}
	
	// get the size of the VFS header 
	vfs_header.size = 7;		// first 6 bytes are V,F,S,H,D,R; next 1 is u8 numStrings
	for(i = 0; i < numStrings; i++)
	{
		vfs_header.size += strlen(stringsShort[i]) + 1;		// we include the NULL
		vfs_header.size += 8;								// 2 u32's for memory addresses
	}
	
	// write the magic VFS_HDR value
	fwrite(vfs_header.VFS_HDR, 6, 1, out);
	
	// write out number of file entries
	fwrite(&numStrings, 1, 1, out);
	
	// write info for all our included files
	char *str = NULL;
	int j = 0;
	
	for(i = 0; i < numStrings; i++)
	{
		// convert the spaces and '.' to appropriate characters
		str = stringsShort[i].GetBuffer(1);
		j = 0;

		while(str[j] != '\0')
		{
			if(str[j] == ' ')			// convert spaces to x's
				str[j] = 'x';

			if(str[j] == '.')			// convert '.' to '_'
				str[j] = '_';
			
			fputc(str[j], out);			// write the character to file
			j++;
		}
			
		fputc('\0', out);	// write out the terminating NULL
		
		stringsShort[i].ReleaseBuffer();

		// get the starting memory address
		mem_addr = 0x08000000 + firstPadSize + vfs_header.size + mem_offset;
		fwrite(&mem_addr, 4, 1, out);

		// get the ending memory address
		CFile::GetStatus(strings[i], status);
		mem_addr = 0x08000000 + firstPadSize + vfs_header.size + mem_offset + status.m_size - 1;
		fwrite(&mem_addr, 4, 1, out);

		mem_offset += status.m_size;
	}

	// copy over data from files
	for(i = 0; i < numStrings; i++)
	{
		// open each file
		in = fopen(strings[i], "rb");
		if(!in)
		{
			MessageBox("Error opening file to be included in VFS.");
			return 0;
		}

		// copy each file
		data = (unsigned char) fgetc(in);

		while(!feof(in))
		{
			fputc(data, out);
			data = (unsigned char) fgetc(in);
		}
		fclose(in);
	}
	
	fclose(out);
	return 1;
}
