/*
	input.h

	Input memory addresses and such.

	Copyright (C) 2001 Sparkle Game Company
*/

#ifndef INPUT_H
#define INPUT_H

#include "sdtypes.h"		

/* button memory addresses */
#define KEY_REG			(*((u32 *)0x04000130))
#define KEY_A			0x0001
#define KEY_B			0x0002
#define KEY_SELECT		0x0004
#define KEY_START		0x0008
#define KEY_RIGHT		0x0010
#define KEY_LEFT		0x0020
#define KEY_UP			0x0040
#define KEY_DOWN		0x0080
#define KEY_R			0x0100
#define KEY_L			0x0200

/* 
	handy macro 

	Multiple button presses can be detected at the same time.
	For example:   if(KEY(KEY_A & KEY_B) { ... }

 */
#define KEY(x)			(!(KEY_REG & (x)))

#endif /* INPUT_H */