/*
	main.c

	main()

	Copyright (C) 2001 Sparkle Game Company
*/

#include "sdtypes.h"
#include "gfx.h"
#include "input.h"
#include "tile.h"
#include <stdlib.h>
#include <string.h>
#include "vfs.h"

#include "rdebug.h"

u16 *MAP_ADDRESS	= (u16 *)	0x06004000;
u16 *TILE_ADDRESS	= (u16 *)	0x06000000;


int main(void)
{
	u16 *pal;
	u8 *gfx;
	u16 *map;
	u16 x, y;
	
	set_gfx_mode(GFX_MODE0);
	
	/* set tile data address to block 0 */
	*((u16 *)BG0_CTRL) |= (0 << BG_TILE_SHIFT);
	/* set map data address to block 8 */
	*((u16 *)BG0_CTRL) |= (8 << BG_MAP_SHIFT);
	*((u16 *)BG0_CTRL) |= BG_256COLOR;

	pal = (u16 *)vfs_fopen("gpal.pal");
	gfx = (u8 *)vfs_fopen("GTILES.T00");
	map = (u16 *)vfs_fopen("GMAP.R00");
	
	set_bg_palette(pal);

	/* set_sprite_palette(pal); */

	for(y = 0; y < 20; y++)
		for(x = 0; x < 30; x++)
		{
			MAP_ADDRESS[x + y*32] = map[x + y*50];
		}
	
	
	memcpy(TILE_ADDRESS, gfx, 3840);
		
	enable_bg0();
	
	while(1)
	{
	}

	return 0;
}
