/*

	Defines for SeeR.

	Copyright (c) 2001 Sparkle
*/

/* logical operator defines */
#define AND		&&
#define OR		||
#define NOT(x)	(!(x))

/* complex arithmetic operator defines */
#define add			+=
#define subtract	-=
#define multiply	*=
#define divide		/=
#define inc			++

/* pointer operation defines */
#define decl_pointer	*
#define address(x)		(&(x))
#define at(x)			(*(x))
#define pointer(x)		(x)

/* variable defines */
#define integer		int
#define real		float
#define letter		char
#define phrase		char *

/* directions */
#define UP		0
#define DOWN	1
#define LEFT	2
#define RIGHT	3


export main;

/* 
	In SeeR, an unsigned long is 64bit, so we simply use
	ints in our definition here, even though the definition
	in the C source files says unsigned long.
*/

import void enemy_ai();

import void fire_spell_display();
import void ice_spell_run();

/* map */
import int	map_load(char *filename);
import void map_draw();
import void map_draw_fg();
import void map_move(int direction, int distance);
import int new_map;

/* music */
import int music_play(char *file);
import int music_stop();
import int music_pause();
import void process_music_events();
import int load_music_events(char *file);

import int talk();

import void display_npc_dialog(int npc_handle);

/* character */
import int	create_npc(int x, int y, int w, int h, char *gfx);
import void destroy_npc(int handle);
import int	create_party_member(int x, int y, int w, int h, char *gfx);
import void destroy_party_member(int handle);
import int	create_enemy(int x, int y, int w, int h, char *gfx);
import void destroy_enemy(int handle);

import void move_party(int dir, int dist);
import void draw_characters();
import int set_npc_dialog(int npc_handle, char *dialog);

/* control */

import int up();
import int down();
import int left();
import int right();
import int select();
import int start();
import int a();
import int b();
import int l();
import int r();
import int read_joystick();
import int key_esc();
import int key_z();
import int key_s();

/* graphics */
import void update_screen();

/* battle */
import void attack();

/* events */
import void process_warp_events();
import int warping;

/* misc */
import void limit_pc_cycles();
import void toggle_zoom();
import void screen_save();

/* the following are implemented as handles */

typedef int ENEMY;					/* enemy */
typedef int NPC;					/* townspeople, etc */
typedef int PLAYERC;				/* playable characters */