/*
    animation.h

    Last Coder : Greg

    Last Update : 6/9/01

    Last Changes : Created file.

     2001 Sparkle

    Animation system.

*/

#ifndef ANIMATION_H
#define ANIMATION_H

/* ANIMATION

	This is the basic unit type for a sprite.  Sprites are made up
	of several rows of animations used for walking, dying, etc.
*/

typedef struct _ANIMATION
{
	BITMAP **frames;
	int num_frames;
	int current_frame;
	int loop;

	int anim_speed;
	int anim_count;
	
	int width, height;
	int animating;

} ANIMATION;


ANIMATION *rm_animation_create(BITMAP *bmp, int x_off, int y_off, int speed);
int rm_animation_destroy(ANIMATION *a);
int rm_animation_update(ANIMATION *a);

#endif /* ANIMATION_H */