/*
    display.c

    Last Coder : Greg

    Last Update : 6/16/01

    Last Changes : Created file.

     2001 Sparkle

    Contains the functions for initializing and
	updating the screen.

*/

#include <allegro.h>
#include "display.h"

int display_corrupted = 0;
int display_faded = 0;
int color_black;

BITMAP *demo_bg = NULL;				/* the GBA picture */
BITMAP *gba_screen = NULL;

/* void rm_display_fade_out()

	Fades the screen to black.
*/

void rm_display_fade_out()
{
	BITMAP *rect;
	int i;

	if(display_faded)
		return;

	rect = create_bitmap(240, 160);
	clear(rect);
		
	
	for(i = 0; i < 8; i++)
	{
		draw_trans_sprite(gba_screen, rect, 0, 0);
		rm_display_draw();
		rest(150);
	}
	
	
	display_faded = 1;
	destroy_bitmap(rect);
}

/* void rm_display_fade_in()

	Returns the screen back to normal colors after a fade out.
*/

void rm_display_fade_in()
{
	BITMAP *tmp;
	int i;
	
	if(!display_faded)
		return;

	display_faded = 0;

	tmp = create_bitmap(240, 160);
	blit(gba_screen, tmp, 0, 0, 0, 0, 240, 160);
	clear(gba_screen);

	for(i = 0; i < 8; i++)
	{
		draw_trans_sprite(gba_screen, tmp, 0, 0);
		rm_display_draw();
		rest(150);
	}
}


/* void rm_display_all()

	Call this function when the screen becomes corrupted.
	For example, when the volume is changed, the background
	image needs to be redrawn.
*/

void rm_display_all()
{
	display_corrupted = 1;
}


/* void rm_display_draw()

	This function updates the screen.  It copies the gba_screen
	and the demo_bg (if necessary) to the screen
*/

void rm_display_draw()
{
	acquire_screen();
	
	if(display_corrupted)
	{
		blit(demo_bg, screen, 0, 0, 0, 0, 640, 480);
		display_corrupted = 0;
	}

	if(display_faded)
		rectfill(screen, 195, 155, 435, 315, color_black);
	else
		blit(gba_screen, screen, 0, 0, 195, 155, 240, 160);
	
	release_screen();
}


/* int rm_display_init()

	This function sets up the display.	Returns 0 on failure,
	or 1 on success.
*/

int rm_display_init()
{
	PALETTE pal;
	
	demo_bg = load_bitmap("bg.pcx", pal);
	
	if(!demo_bg)
	{
		allegro_message("Error opening bg.pcx!");
		exit(0);
	}

	gba_screen = create_bitmap(240, 160);
	
	if(!gba_screen)
		return 0;

	clear(gba_screen);

	color_black = makecol(0, 0, 0);
	
	return 1;
}