/*
    init.c

    Last Coder : Greg

    Last Update : 6/8/01

    Last Changes : Created file.

     2001 Sparkle

    Initialization.

*/

#include <allegro.h>
#include "init.h"
#include "timer.h"
#include "sound.h"
#include "display.h"

/* int rm_init()

	Gets everything initialized and ready to go.
	Returns 0 on failure.
*/

int rm_init()
{
	allegro_init();
	install_timer();
	install_keyboard();
	
	set_window_title("Remember Me - Demo");

	set_color_depth(16);

	if(set_gfx_mode(GFX_DIRECTX, 640, 480, 0, 0) < 0)
	{
		allegro_message("Graphics mode not supported.");
		exit(0);
	}

	rm_timer_init();
	
	if(rm_sound_init() != SR_OK)
	{
		allegro_message("Unable to initialize sound!");
		exit(0);
	}

	rm_display_init();
	set_trans_blender(128, 128, 128, 128);

	return 1;
}