/*
    sprite.h

    Last Coder : Greg

    Last Update : 6/8/01

    Last Changes : Created file.

     2001 Sparkle

    Sprites.

*/

#ifndef SPRITE_H
#define SPRITE_H

typedef struct _SPRITE
{
	ANIMATION **anim;
	
	int current_set;				/* current animation set */
	int num_sets;					/* number of animation sets */

	int motion_speed;				/* time in between movement */
	int motion_count;				/* used in keeping time */
	int motion_dist;				/* the distance the sprite moves (in pixels) */
	
	int x, y;
	int x_old, y_old;				/* old sprite position */

} SPRITE;


SPRITE *rm_sprite_create(char *gfx, int speed, int dist, int x, int y);
int rm_sprite_destroy(SPRITE *s);
int rm_sprite_draw(BITMAP *bmp, SPRITE *s);
int rm_sprite_animate(SPRITE *s);
int rm_sprite_set_loop(SPRITE *s, int status);
int rm_sprite_collision(SPRITE *a, SPRITE *b);

#endif /* SPRITE_H */